-- Sistemas Integrados TEKNISA
-- Faturamento de Servios
--
-- Nome: 0000_RHMFUNO_USR_DIF_DIAS_PONTO_ANT.sql
--
-- Descrio:
-- Retorna a diferena em dias entre uma data e o ponto anterior a esta data.
--
-- Parmetros:
-- P_CDEMPRESA - Identificador de licena de uso ativa
-- P_CDFUNC - Data de validade do arquivo de personalizao gerado com licena de uso pendente (no paga)
-- P_DTPONTO - Data de validade do arquivo de personalizao gerado com licena de uso paga
--
-- Retorno:
-- Diferena em dias entre a data passada como parmetro e ltimo ponto ponto anterior a esta data.
--
-- Criao:
-- 05/05/2010 Ederson Melquades da Cunha


CREATE FUNCTION USR_DIF_DIAS_PONTO_ANT
  (P_CDEMPRESA VARCHAR2,
   P_CDFUNC VARCHAR2,
   P_DTPONTO DATE)
RETURN NUMBER IS
V_DATA DATE;
V_DIF_DIAS NUMBER;
BEGIN
  SELECT NVL(MAX(DTPONTO), P_DTPONTO-1)
    INTO V_DATA
    FROM PONTO
   WHERE CDEMPRESA = P_CDEMPRESA
     AND CDFUNC = P_CDFUNC
     AND DTPONTO < P_DTPONTO;
  V_DIF_DIAS := (P_DTPONTO - V_DATA) - 1;
  RETURN (V_DIF_DIAS);
END;