/* ======= Tabela COMPENSACONTREC: Compensao de Contas a Receber =======*/
/* ======= Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela COMPENSACONTREC */
/* ======= Objetivo: Gerar um log que vai registrar as alteraes na tabela Compensao de Contas a Receber,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIN_COMPENSACONTREC' AND
                 TYPE   = 'TR' 		           AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIN_COMPENSACONTREC
GO


CREATE TRIGGER LOG_FIN_COMPENSACONTREC
ON COMPENSACONTREC
FOR INSERT, UPDATE, DELETE
AS


   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;
   DECLARE  @V_DSREMOTEADDR VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST VARCHAR(15);
   DECLARE  @V_DSSERVERRDM  VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER VARCHAR(12);

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO    VARCHAR(1);

   DECLARE @V_OLD_CDEMPRESA       VARCHAR(2 );
   DECLARE @V_OLD_NRLANCCOMPREC   VARCHAR(10);
   DECLARE @V_OLD_CDFILIAL        VARCHAR(4 );
   DECLARE @V_OLD_NRLANBOLREC     VARCHAR(10);
   DECLARE @V_OLD_CDOPERLANCOMREC VARCHAR(12);
   DECLARE @V_OLD_DTLANCOMCONTREC DATETIME;
   DECLARE @V_OLD_CDCLIENTE       VARCHAR(21);
   DECLARE @V_OLD_DTCOMPCONTREC   DATETIME;
   DECLARE @V_OLD_CDTPBAIXAREC    VARCHAR(2 );
   DECLARE @V_OLD_CDTPBAIXAPAG    VARCHAR(2 );
   DECLARE @V_OLD_CDAJUCTREC     VARCHAR(4 );
   DECLARE @V_OLD_CDAJUCTPAG     VARCHAR(4 );
   DECLARE @V_OLD_CDREDUCONT      VARCHAR(3 );
   DECLARE @V_OLD_DTBAIXACOMPREC  DATETIME;
   DECLARE @V_OLD_CDFILIALBAIREC  VARCHAR(4 );
   DECLARE @V_OLD_NRBAIXAREC      VARCHAR(10);
   DECLARE @V_OLD_CDFILIALBAIPAG  VARCHAR(4 );
   DECLARE @V_OLD_NRBAIXAPAG      VARCHAR(10);
   DECLARE @V_OLD_IDTPITUTLCOMREC VARCHAR( 1);
   DECLARE @V_OLD_QTITCOMCONTREC  DOUBLE PRECISION;
   DECLARE @V_OLD_VRTOTALCOMREC   DOUBLE PRECISION;

   DECLARE @V_NEW_CDEMPRESA       VARCHAR(2 );
   DECLARE @V_NEW_NRLANCCOMPREC   VARCHAR(10);
   DECLARE @V_NEW_CDFILIAL        VARCHAR(4 );
   DECLARE @V_NEW_NRLANBOLREC     VARCHAR(10);
   DECLARE @V_NEW_CDOPERLANCOMREC VARCHAR(12);
   DECLARE @V_NEW_DTLANCOMCONTREC DATETIME;
   DECLARE @V_NEW_CDCLIENTE       VARCHAR(21);
   DECLARE @V_NEW_DTCOMPCONTREC   DATETIME;
   DECLARE @V_NEW_CDTPBAIXAREC    VARCHAR(2 );
   DECLARE @V_NEW_CDTPBAIXAPAG    VARCHAR(2 );
   DECLARE @V_NEW_CDAJUCTREC     VARCHAR(4 );
   DECLARE @V_NEW_CDAJUCTPAG     VARCHAR(4 );
   DECLARE @V_NEW_CDREDUCONT      VARCHAR(3 );
   DECLARE @V_NEW_DTBAIXACOMPREC  DATETIME;
   DECLARE @V_NEW_CDFILIALBAIREC  VARCHAR(4 );
   DECLARE @V_NEW_NRBAIXAREC      VARCHAR(10);
   DECLARE @V_NEW_CDFILIALBAIPAG  VARCHAR(4 );
   DECLARE @V_NEW_NRBAIXAPAG      VARCHAR(10);
   DECLARE @V_NEW_IDTPITUTLCOMREC VARCHAR( 1);
   DECLARE @V_NEW_QTITCOMCONTREC  DOUBLE PRECISION;
   DECLARE @V_NEW_VRTOTALCOMREC   DOUBLE PRECISION;
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER ;

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDEMPRESA,
         NRLANCCOMPREC,
         CDFILIAL,
         NRLANBOLREC,
         CDOPERLANCOMREC,
         DTLANCOMCONTREC,
         CDCLIENTE,
         DTCOMPCONTREC,
         CDTPBAIXAREC,
         CDTPBAIXAPAG,
         CDAJUCTREC,
         CDAJUCTPAG,
         CDREDUCONT,
         DTBAIXACOMPREC,
         CDFILIALBAIREC,
         NRBAIXAREC,
         CDFILIALBAIPAG,
         NRBAIXAPAG,
         IDTPITUTLCOMREC,
         QTITCOMCONTREC,
         VRTOTALCOMREC,


         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
     DELETED
   WHERE
     CDEMPRESA+NRLANCCOMPREC NOT IN (SELECT CDEMPRESA+NRLANCCOMPREC FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
         DELETED.CDEMPRESA,
         DELETED.NRLANCCOMPREC,
         DELETED.CDFILIAL,
         DELETED.NRLANBOLREC,
         DELETED.CDOPERLANCOMREC,
         DELETED.DTLANCOMCONTREC,
         DELETED.CDCLIENTE,
         DELETED.DTCOMPCONTREC,
         DELETED.CDTPBAIXAREC,
         DELETED.CDTPBAIXAPAG,
         DELETED.CDAJUCTREC,
         DELETED.CDAJUCTPAG,
         DELETED.CDREDUCONT,
         DELETED.DTBAIXACOMPREC,
         DELETED.CDFILIALBAIREC,
         DELETED.NRBAIXAREC,
         DELETED.CDFILIALBAIPAG,
         DELETED.NRBAIXAPAG,
         DELETED.IDTPITUTLCOMREC,
         DELETED.QTITCOMCONTREC,
         DELETED.VRTOTALCOMREC,

         INSERTED.CDEMPRESA,
         INSERTED.NRLANCCOMPREC,
         INSERTED.CDFILIAL,
         INSERTED.NRLANBOLREC,
         INSERTED.CDOPERLANCOMREC,
         INSERTED.DTLANCOMCONTREC,
         INSERTED.CDCLIENTE,
         INSERTED.DTCOMPCONTREC,
         INSERTED.CDTPBAIXAREC,
         INSERTED.CDTPBAIXAPAG,
         INSERTED.CDAJUCTREC,
         INSERTED.CDAJUCTPAG,
         INSERTED.CDREDUCONT,
         INSERTED.DTBAIXACOMPREC,
         INSERTED.CDFILIALBAIREC,
         INSERTED.NRBAIXAREC,
         INSERTED.CDFILIALBAIPAG,
         INSERTED.NRBAIXAPAG,
         INSERTED.IDTPITUTLCOMREC,
         INSERTED.QTITCOMCONTREC,
         INSERTED.VRTOTALCOMREC
   FROM
       INSERTED,
       DELETED
    WHERE
       (INSERTED.CDEMPRESA+INSERTED.NRLANCCOMPREC) =
       (DELETED.CDEMPRESA+DELETED.NRLANCCOMPREC)

    UNION ALL

    SELECT
       'I' IDCOMANDO,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,
           NULL,

           INSERTED.CDEMPRESA,
           INSERTED.NRLANCCOMPREC,
           INSERTED.CDFILIAL,
           INSERTED.NRLANBOLREC,
           INSERTED.CDOPERLANCOMREC,
           INSERTED.DTLANCOMCONTREC,
           INSERTED.CDCLIENTE,
           INSERTED.DTCOMPCONTREC,
           INSERTED.CDTPBAIXAREC,
           INSERTED.CDTPBAIXAPAG,
           INSERTED.CDAJUCTREC,
           INSERTED.CDAJUCTPAG,
           INSERTED.CDREDUCONT,
           INSERTED.DTBAIXACOMPREC,
           INSERTED.CDFILIALBAIREC,
           INSERTED.NRBAIXAREC,
           INSERTED.CDFILIALBAIPAG,
           INSERTED.NRBAIXAPAG,
           INSERTED.IDTPITUTLCOMREC,
           INSERTED.QTITCOMCONTREC,
           INSERTED.VRTOTALCOMREC

    FROM
      INSERTED
    WHERE
     CDEMPRESA+NRLANCCOMPREC NOT IN (SELECT CDEMPRESA+NRLANCCOMPREC FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDEMPRESA,
                                 @V_OLD_NRLANCCOMPREC,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_NRLANBOLREC,
                                 @V_OLD_CDOPERLANCOMREC,
                                 @V_OLD_DTLANCOMCONTREC,
                                 @V_OLD_CDCLIENTE,
                                 @V_OLD_DTCOMPCONTREC,
                                 @V_OLD_CDTPBAIXAREC,
                                 @V_OLD_CDTPBAIXAPAG,
                                 @V_OLD_CDAJUCTREC,
                                 @V_OLD_CDAJUCTPAG,
                                 @V_OLD_CDREDUCONT,
                                 @V_OLD_DTBAIXACOMPREC,
                                 @V_OLD_CDFILIALBAIREC,
                                 @V_OLD_NRBAIXAREC,
                                 @V_OLD_CDFILIALBAIPAG,
                                 @V_OLD_NRBAIXAPAG,
                                 @V_OLD_IDTPITUTLCOMREC,
                                 @V_OLD_QTITCOMCONTREC,
                                 @V_OLD_VRTOTALCOMREC,


                                 @V_NEW_CDEMPRESA,
                                 @V_NEW_NRLANCCOMPREC,
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_NRLANBOLREC,
                                 @V_NEW_CDOPERLANCOMREC,
                                 @V_NEW_DTLANCOMCONTREC,
                                 @V_NEW_CDCLIENTE,
                                 @V_NEW_DTCOMPCONTREC,
                                 @V_NEW_CDTPBAIXAREC,
                                 @V_NEW_CDTPBAIXAPAG,
                                 @V_NEW_CDAJUCTREC,
                                 @V_NEW_CDAJUCTPAG,
                                 @V_NEW_CDREDUCONT,
                                 @V_NEW_DTBAIXACOMPREC,
                                 @V_NEW_CDFILIALBAIREC,
                                 @V_NEW_NRBAIXAREC,
                                 @V_NEW_CDFILIALBAIPAG,
                                 @V_NEW_NRBAIXAPAG,
                                 @V_NEW_IDTPITUTLCOMREC,
                                 @V_NEW_QTITCOMCONTREC,
                                 @V_NEW_VRTOTALCOMREC;



   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN /*DELETING*/

         IF @V_OLD_CDEMPRESA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdEmp=' + @V_OLD_CDEMPRESA;
         END;

         IF @V_OLD_NRLANCCOMPREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NroComp=' + @V_OLD_NRLANCCOMPREC;
         END;

         IF (@V_OLD_CDFILIAL IS NOT NULL) AND (@V_OLD_NRLANBOLREC IS NOT NULL) BEGIN
            SET @V_DESC = @V_DESC + ' ChaveBol=' + @V_OLD_CDFILIAL + @V_OLD_NRLANBOLREC;
         END;

         IF @V_OLD_CDOPERLANCOMREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdOpLanc=' + @V_OLD_CDOPERLANCOMREC;
         END;

         IF @V_OLD_DTLANCOMCONTREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtLancC=' + CONVERT(VARCHAR, @V_OLD_DTLANCOMCONTREC, 103);
         END;

         IF @V_OLD_CDCLIENTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdClie=' + @V_OLD_CDCLIENTE;
         END;

         IF @V_OLD_DTCOMPCONTREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtCompRec=' + CONVERT(VARCHAR, @V_OLD_DTCOMPCONTREC, 103);
         END;

         IF @V_OLD_CDTPBAIXAREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpBxRec=' + @V_OLD_CDTPBAIXAREC;
         END;

         IF @V_OLD_CDTPBAIXAPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpBxPag=' + @V_OLD_CDTPBAIXAPAG;
         END;

         IF @V_OLD_CDAJUCTREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpAjRec=' +  @V_OLD_CDAJUCTREC;
         END;

         IF @V_OLD_CDAJUCTPAG IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpAjPag=' +  @V_OLD_CDAJUCTPAG;
         END;

         IF @V_OLD_CDREDUCONT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdReCont=' + @V_OLD_CDREDUCONT;
         END;

         IF @V_OLD_DTBAIXACOMPREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtBxComp=' + CONVERT(VARCHAR, @V_OLD_DTBAIXACOMPREC, 103);
         END;

         IF (@V_OLD_CDFILIALBAIREC IS NOT NULL) AND (@V_OLD_NRBAIXAREC IS NOT NULL) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxRec=' + @V_OLD_CDFILIALBAIREC + @V_OLD_NRBAIXAREC;
         END;

         IF (@V_OLD_CDFILIALBAIPAG IS NOT NULL) AND (@V_OLD_NRBAIXAPAG IS NOT NULL) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxPag=' + @V_OLD_CDFILIALBAIPAG + @V_OLD_NRBAIXAPAG;
         END;
         IF @V_OLD_IDTPITUTLCOMREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdItem=' + @V_OLD_IDTPITUTLCOMREC;
         END;
         IF @V_OLD_QTITCOMCONTREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' QtItens=' + CONVERT(VARCHAR, @V_OLD_QTITCOMCONTREC);
         END;

         IF @V_OLD_VRTOTALCOMREC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrComp=' + CONVERT(VARCHAR, @V_OLD_VRTOTALCOMREC);
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDEMPRESA + @V_OLD_NRLANCCOMPREC;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' BEGIN /*UPDATING*/
            IF (ISNULL(@V_OLD_CDEMPRESA,       '0') <> ISNULL(@V_NEW_CDEMPRESA,       '0')) OR
               (ISNULL(@V_OLD_NRLANCCOMPREC,   '0') <> ISNULL(@V_NEW_NRLANCCOMPREC,   '0')) OR
               (ISNULL(@V_OLD_CDFILIAL,        '0') <> ISNULL(@V_NEW_CDFILIAL,        '0')) OR
               (ISNULL(@V_OLD_NRLANBOLREC,     '0') <> ISNULL(@V_NEW_NRLANBOLREC,     '0')) OR
               (ISNULL(@V_OLD_CDOPERLANCOMREC, '0') <> ISNULL(@V_NEW_CDOPERLANCOMREC, '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_DTLANCOMCONTREC, 103), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTLANCOMCONTREC, 103), '0')) OR
               (ISNULL(@V_OLD_CDCLIENTE,       '0') <> ISNULL(@V_NEW_CDCLIENTE,       '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_DTCOMPCONTREC, 103),   '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTCOMPCONTREC, 103),   '0')) OR
               (ISNULL(@V_OLD_CDTPBAIXAREC,    '0') <> ISNULL(@V_NEW_CDTPBAIXAREC,    '0')) OR
               (ISNULL(@V_OLD_CDTPBAIXAPAG,    '0') <> ISNULL(@V_NEW_CDTPBAIXAPAG,    '0')) OR
               (ISNULL(@V_OLD_CDAJUCTREC,     '0') <> ISNULL(@V_NEW_CDAJUCTREC,     '0')) OR
               (ISNULL(@V_OLD_CDAJUCTPAG,     '0') <> ISNULL(@V_NEW_CDAJUCTPAG,     '0')) OR
               (ISNULL(@V_OLD_CDREDUCONT,      '0') <> ISNULL(@V_NEW_CDREDUCONT,      '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_DTBAIXACOMPREC, 103),  '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTBAIXACOMPREC, 103),  '0')) OR
               (ISNULL(@V_OLD_CDFILIALBAIREC,  '0') <> ISNULL(@V_NEW_CDFILIALBAIREC,  '0')) OR
               (ISNULL(@V_OLD_NRBAIXAREC,      '0') <> ISNULL(@V_NEW_NRBAIXAREC,      '0')) OR
               (ISNULL(@V_OLD_CDFILIALBAIPAG,  '0') <> ISNULL(@V_OLD_CDFILIALBAIPAG,  '0')) OR
               (ISNULL(@V_OLD_NRBAIXAPAG,      '0') <> ISNULL(@V_NEW_NRBAIXAPAG,      '0')) OR
               (ISNULL(@V_OLD_IDTPITUTLCOMREC, '0') <> ISNULL(@V_NEW_IDTPITUTLCOMREC, '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_QTITCOMCONTREC),  '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_QTITCOMCONTREC),  '0')) OR
               (ISNULL(CONVERT(VARCHAR, @V_OLD_VRTOTALCOMREC),   '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_VRTOTALCOMREC),   '0')) BEGIN

                SET @V_ITPESQ = @V_OLD_CDEMPRESA + @V_OLD_NRLANCCOMPREC;
                SET @V_TIPO   = '2';
            END;
         END
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDEMPRESA + @V_NEW_NRLANCCOMPREC;
         END;
         IF ISNULL(@V_OLD_CDEMPRESA, '0') <> ISNULL(@V_NEW_CDEMPRESA, '0') BEGIN
            SET @V_DESC = @V_DESC + 'CdEmp=' + @V_NEW_CDEMPRESA;
         END;

         IF ISNULL(@V_OLD_NRLANCCOMPREC,'0') <>  ISNULL(@V_NEW_NRLANCCOMPREC,'0') BEGIN
            SET @V_DESC = @V_DESC + ' NroComp=' + @V_NEW_NRLANCCOMPREC;
         END;

         IF (ISNULL(@V_OLD_CDFILIAL, '0') <> ISNULL(@V_NEW_CDFILIAL, '0')) OR
            (ISNULL(@V_OLD_NRLANBOLREC,'0') <>  ISNULL(@V_NEW_NRLANBOLREC,'0')) BEGIN
            SET @V_DESC = @V_DESC + ' ChaveBol=' + @V_NEW_CDFILIAL + @V_NEW_NRLANBOLREC;
         END;

         IF ISNULL(@V_OLD_CDOPERLANCOMREC,'0') <> ISNULL(@V_NEW_CDOPERLANCOMREC, '0') BEGIN
            SET @V_DESC = @V_DESC + ' CdOpLanc=' + @V_NEW_CDOPERLANCOMREC;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_DTLANCOMCONTREC, 103), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTLANCOMCONTREC, 103), '0') BEGIN
            SET @V_DESC = @V_DESC + ' DtLancC=' + CONVERT(VARCHAR, @V_NEW_DTLANCOMCONTREC, 103);
         END;

         IF ISNULL(@V_OLD_CDCLIENTE, '0') <>  ISNULL(@V_NEW_CDCLIENTE, '0') BEGIN
            SET @V_DESC = @V_DESC + ' CdClie=' + @V_NEW_CDCLIENTE;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_DTCOMPCONTREC, 103), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTCOMPCONTREC, 103), '0') BEGIN
            SET @V_DESC = @V_DESC + ' DtCompRec=' + CONVERT(VARCHAR, @V_NEW_DTCOMPCONTREC, 103);
         END;

         IF ISNULL(@V_OLD_CDTPBAIXAREC, '0') <> ISNULL(@V_NEW_CDTPBAIXAREC, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpBxRec=' + @V_NEW_CDTPBAIXAREC;
         END;

         IF ISNULL(@V_OLD_CDTPBAIXAPAG, '0') <> ISNULL(@V_NEW_CDTPBAIXAPAG, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpBxPag=' + @V_NEW_CDTPBAIXAPAG;
         END;

         IF ISNULL(@V_OLD_CDAJUCTREC, '0') <> ISNULL(@V_NEW_CDAJUCTREC, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpAjRec=' +  @V_NEW_CDAJUCTREC;
         END;

         IF ISNULL(@V_OLD_CDAJUCTPAG, '0') <> ISNULL(@V_NEW_CDAJUCTPAG, '0') BEGIN
            SET @V_DESC = @V_DESC + ' TpAjPag=' +  @V_NEW_CDAJUCTPAG;
         END;

         IF ISNULL(@V_OLD_CDREDUCONT, '0') <> ISNULL(@V_NEW_CDREDUCONT, '0') BEGIN
            SET @V_DESC = @V_DESC + ' CdReCont=' + @V_NEW_CDREDUCONT;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_DTBAIXACOMPREC, 103), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_DTBAIXACOMPREC, 103), '0') BEGIN
            SET @V_DESC = @V_DESC + ' DtBxComp=' + CONVERT(VARCHAR, @V_NEW_DTBAIXACOMPREC, 103);
         END;

         IF (ISNULL(@V_OLD_CDFILIALBAIREC, '0') <> ISNULL(@V_NEW_CDFILIALBAIREC, '0')) OR
            (ISNULL(@V_OLD_NRBAIXAREC, '0') <> ISNULL(@V_NEW_NRBAIXAREC, '0')) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxRec=' + @V_NEW_CDFILIALBAIREC + @V_NEW_NRBAIXAREC;
         END;

         IF (ISNULL(@V_OLD_CDFILIALBAIPAG, '0') <> ISNULL(@V_NEW_CDFILIALBAIPAG, '0')) OR
            (ISNULL(@V_OLD_NRBAIXAPAG, '0') <>  ISNULL(@V_NEW_NRBAIXAPAG, '0')) BEGIN
            SET @V_DESC = @V_DESC + ' ChavBxPag=' + @V_NEW_CDFILIALBAIPAG + @V_NEW_NRBAIXAPAG;
         END;

         IF ISNULL(@V_OLD_IDTPITUTLCOMREC, '0') <> ISNULL(@V_NEW_IDTPITUTLCOMREC, '0') BEGIN
            SET @V_DESC = @V_DESC + ' IdItem=' + @V_NEW_IDTPITUTLCOMREC;
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_QTITCOMCONTREC), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_QTITCOMCONTREC), '0') BEGIN
            SET @V_DESC = @V_DESC + ' QtItens=' + CONVERT(VARCHAR, @V_NEW_QTITCOMCONTREC);
         END;

         IF ISNULL(CONVERT(VARCHAR, @V_OLD_VRTOTALCOMREC), '0') <> ISNULL(CONVERT(VARCHAR, @V_NEW_VRTOTALCOMREC), '0') BEGIN
            SET @V_DESC = @V_DESC + ' VrComp=' + CONVERT(VARCHAR, @V_NEW_VRTOTALCOMREC);
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL AND @V_DESC <> '' BEGIN
            EXEC NMUSUARIO @V_USUARIO;
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('COMPENSACONTREC',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO, @V_ITPESQ, @V_DESC, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM,
                   @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDEMPRESA,
                                    @V_OLD_NRLANCCOMPREC,
                                    @V_OLD_CDFILIAL,
                                    @V_OLD_NRLANBOLREC,
                                    @V_OLD_CDOPERLANCOMREC,
                                    @V_OLD_DTLANCOMCONTREC,
                                    @V_OLD_CDCLIENTE,
                                    @V_OLD_DTCOMPCONTREC,
                                    @V_OLD_CDTPBAIXAREC,
                                    @V_OLD_CDTPBAIXAPAG,
                                    @V_OLD_CDAJUCTREC,
                                    @V_OLD_CDAJUCTPAG,
                                    @V_OLD_CDREDUCONT,
                                    @V_OLD_DTBAIXACOMPREC,
                                    @V_OLD_CDFILIALBAIREC,
                                    @V_OLD_NRBAIXAREC,
                                    @V_OLD_CDFILIALBAIPAG,
                                    @V_OLD_NRBAIXAPAG,
                                    @V_OLD_IDTPITUTLCOMREC,
                                    @V_OLD_QTITCOMCONTREC,
                                    @V_OLD_VRTOTALCOMREC,


                                    @V_NEW_CDEMPRESA,
                                    @V_NEW_NRLANCCOMPREC,
                                    @V_NEW_CDFILIAL,
                                    @V_NEW_NRLANBOLREC,
                                    @V_NEW_CDOPERLANCOMREC,
                                    @V_NEW_DTLANCOMCONTREC,
                                    @V_NEW_CDCLIENTE,
                                    @V_NEW_DTCOMPCONTREC,
                                    @V_NEW_CDTPBAIXAREC,
                                    @V_NEW_CDTPBAIXAPAG,
                                    @V_NEW_CDAJUCTREC,
                                    @V_NEW_CDAJUCTPAG,
                                    @V_NEW_CDREDUCONT,
                                    @V_NEW_DTBAIXACOMPREC,
                                    @V_NEW_CDFILIALBAIREC,
                                    @V_NEW_NRBAIXAREC,
                                    @V_NEW_CDFILIALBAIPAG,
                                    @V_NEW_NRBAIXAPAG,
                                    @V_NEW_IDTPITUTLCOMREC,
                                    @V_NEW_QTITCOMCONTREC,
                                    @V_NEW_VRTOTALCOMREC;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIN_COMPENSACONTREC','5.05.105';
GO

