IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FILIALOPEROP'   AND
                 TYPE   = 'TR'                   AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_FILIALOPEROP         
GO


CREATE TRIGGER LOG_FILIALOPEROP
ON FILIALOPEROP
FOR INSERT, DELETE, UPDATE
AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO   VARCHAR(1);

   DECLARE  @V_OLD_CDFILIAL        VARCHAR(4);
   DECLARE  @V_OLD_CDGRUPGERENTEOP VARCHAR(10);
   DECLARE  @V_OLD_CDOPERADOR      VARCHAR(12);
   DECLARE  @V_OLD_IDACESSOCALC    VARCHAR(1);
   DECLARE  @V_OLD_IDACESSOAPROV   VARCHAR(1);

   DECLARE  @V_NEW_CDFILIAL        VARCHAR(4);
   DECLARE  @V_NEW_CDGRUPGERENTEOP VARCHAR(10);
   DECLARE  @V_NEW_CDOPERADOR      VARCHAR(12);
   DECLARE  @V_NEW_IDACESSOCALC    VARCHAR(1);
   DECLARE  @V_NEW_IDACESSOAPROV   VARCHAR(1);

BEGIN

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      CDFILIAL,
      CDGRUPGERENTEOP,
      CDOPERADOR,
      IDACESSOCALC,
      IDACESSOAPROV,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE CDFILIAL        NOT IN (SELECT CDFILIAL        FROM INSERTED)
     AND CDGRUPGERENTEOP NOT IN (SELECT CDGRUPGERENTEOP FROM INSERTED)
     AND CDOPERADOR      NOT IN (SELECT CDOPERADOR      FROM INSERTED)

   UNION ALL

   SELECT
      'U' IDCOMANDO,
      DELETED.CDFILIAL,
      DELETED.CDGRUPGERENTEOP,
      DELETED.CDOPERADOR,
      DELETED.IDACESSOCALC,
      DELETED.IDACESSOAPROV,

      INSERTED.CDFILIAL,
      INSERTED.CDGRUPGERENTEOP,
      INSERTED.CDOPERADOR,
      INSERTED.IDACESSOCALC,
      INSERTED.IDACESSOAPROV
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDFILIAL        = DELETED.CDFILIAL
     AND INSERTED.CDGRUPGERENTEOP = DELETED.CDGRUPGERENTEOP
     AND INSERTED.CDOPERADOR      = DELETED.CDOPERADOR
   UNION ALL

   SELECT
      'I' IDCOMANDO,

      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDFILIAL,
      CDGRUPGERENTEOP,
      CDOPERADOR,
      IDACESSOCALC,
      IDACESSOAPROV
   FROM
      INSERTED
   WHERE CDFILIAL        NOT IN (SELECT CDFILIAL        FROM DELETED)
     AND CDGRUPGERENTEOP NOT IN (SELECT CDGRUPGERENTEOP FROM DELETED)
     AND CDOPERADOR      NOT IN (SELECT CDOPERADOR      FROM DELETED)
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_CDGRUPGERENTEOP,
                                 @V_OLD_CDOPERADOR,
                                 @V_OLD_IDACESSOCALC,
                                 @V_OLD_IDACESSOAPROV,
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_CDGRUPGERENTEOP,
                                 @V_NEW_CDOPERADOR,
                                 @V_NEW_IDACESSOCALC,
                                 @V_NEW_IDACESSOAPROV;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdFilial=' + @V_OLD_CDFILIAL;
         END;
         IF @V_OLD_CDGRUPGERENTEOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdGrupGerente=' + @V_OLD_CDGRUPGERENTEOP;
         END;
         IF @V_OLD_CDOPERADOR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdOperador=' + @V_OLD_CDOPERADOR
         END;

         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDFILIAL+';'+@V_OLD_CDGRUPGERENTEOP+';'+@V_OLD_CDOPERADOR;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U' BEGIN
            IF (@V_OLD_IDACESSOCALC <> @V_NEW_IDACESSOCALC) BEGIN
               SET @V_DESC = @V_DESC + ' IdAcessoCalc=' + @V_NEW_IDACESSOCALC;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFILIAL+';'+@V_OLD_CDGRUPGERENTEOP+';'+@V_OLD_CDOPERADOR;

            END;
            IF (@V_OLD_IDACESSOAPROV <> @V_NEW_IDACESSOAPROV) BEGIN
               SET @V_DESC = @V_DESC + ' IdAcessoAprov=' + @V_NEW_IDACESSOAPROV;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFILIAL+';'+@V_OLD_CDGRUPGERENTEOP+';'+@V_OLD_CDOPERADOR;

            END;

         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDFILIAL+';'+@V_NEW_CDGRUPGERENTEOP+';'+@V_NEW_CDOPERADOR;

            IF ISNULL(@V_NEW_CDFILIAL,'!') <> ISNULL(@V_OLD_CDFILIAL,'!') BEGIN
               SET @V_DESC = @V_DESC + ' CdFilial=' + @V_NEW_CDFILIAL;
            END;

            IF ISNULL(@V_NEW_CDGRUPGERENTEOP ,'!') <> ISNULL(@V_OLD_CDGRUPGERENTEOP, '!') BEGIN
               SET @V_DESC = @V_DESC + ' CdGrupGerente=' + @V_NEW_CDGRUPGERENTEOP;
            END;
            IF ISNULL(@V_NEW_CDOPERADOR ,'!') <> ISNULL(@V_OLD_CDOPERADOR, '!') BEGIN
               SET @V_DESC = @V_DESC + ' CdOperador=' + @V_NEW_CDOPERADOR;
            END;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('FILIALOPEROP',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDFILIAL,
                                    @V_OLD_CDGRUPGERENTEOP,
                                    @V_OLD_CDOPERADOR,
                                    @V_OLD_IDACESSOCALC,
                                    @V_OLD_IDACESSOAPROV,
                                    @V_NEW_CDFILIAL,
                                    @V_NEW_CDGRUPGERENTEOP,
                                    @V_NEW_CDOPERADOR,
                                    @V_NEW_IDACESSOCALC,
                                    @V_NEW_IDACESSOAPROV;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FILIALOPEROP','5.09.000';
GO

